/*
 * cc1120_mango_porting.h
 */

#ifndef __CC1120_MANGO_PORTING_H
#define __CC1120_MANGO_PORTING_H

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"
#include "stm32f10x_spi.h"
#include "hal_types.h"
#include "stm32f10x_gpio.h"

/* Exported types ------------------------------------------------------------*/

typedef struct
{
  uint16  addr;
  uint8   data;
}registerSetting_t;

typedef uint8 rfStatus_t;

#define RADIO_BURST_ACCESS   0x40
#define RADIO_SINGLE_ACCESS  0x00
#define RADIO_READ_ACCESS    0x80
#define RADIO_WRITE_ACCESS   0x00

/* Bit fields in the chip status byte */
#define STATUS_CHIP_RDYn_BM             0x80
#define STATUS_STATE_BM                 0x70
#define STATUS_FIFO_BYTES_AVAILABLE_BM  0x0F

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

#define GPIO_PORTSOURCE_CC1120_GPIO   GPIO_PortSourceGPIOD

#define HAL_INT_ON(x)      ;
#define HAL_INT_OFF(x)     ;
#define HAL_INT_LOCK(x)    ;
#define HAL_INT_UNLOCK(x)  ;

void CC1120_SPI_BEGIN(void);
void CC1120_SPI_END(void);

/* External variables --------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

rfStatus_t trx8BitRegAccess(uint8 accessType, uint8 addrByte, uint8 *pData, uint16 len);
rfStatus_t trxSpiCmdStrobe(uint8 cmd);

/* CC112X specific prototype function */
rfStatus_t trx16BitRegAccess(uint8 accessType, uint8 extAddr, uint8 regAddr, uint8 *pData, uint8 len);

void CC1120_GPIO_0_Interrupt_Setting(FunctionalState  fStateE);
void CC1120_GPIO_2_Interrupt_Setting(FunctionalState  fStateE);

void CC1120_SPI_TX(u8 data);
u8 CC1120_SPI_RX(void);
void CC1120_SPI_WAIT_RXRDY(void);
uint8 CC1120_SPI_TXRX(uint8 x);

#endif  /* __CC1120_MANGO_PORTING_H */
