/*
 * i2c_test.c
 */

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"

// ##############################################################################
// I2C Test OLD
// ##############################################################################

#define ClockSpeed   400000

/**
  * @brief  Configures I2C1
  * @param  None
  * @retval : None
  */
void Master_Configuration(void)
{
    I2C_InitTypeDef  I2C_InitStructure;

    I2C_DeInit(I2C1);
    /* I2C1 Init */
    I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
    I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
    I2C_InitStructure.I2C_OwnAddress1 = 0x30;
    I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
    I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
    I2C_InitStructure.I2C_ClockSpeed = ClockSpeed;
    I2C_Init(I2C1, &I2C_InitStructure);
    I2C_ITConfig(I2C1, I2C_IT_ERR , ENABLE);
}

#define BufferSize   6

uint8_t Master_Buffer_Rx[BufferSize];
uint8_t Master_Buffer_Tx[BufferSize];

void I2C_Test_Old(void)
{
    ErrorStatus  errSts;

    printf("I2C Test Old\n");

    /* I2C1 Master configuration ------------------------------------------------------*/
    Master_Configuration();

    Delay(500);

    I2C_Check_Busy_Flag(I2C1);
    Master_Buffer_Tx[0] = 0x00;
    errSts = I2C_Master_BufferWrite_Old(I2C1, SLAVE_ADDRESS, Master_Buffer_Tx, 1);
    if(ERROR == errSts)
    {
        printf("[ERROR] I2C_Master_BufferWrite() error\n");
    }
    printf("I2C_Master_BufferWrite() done\n");

    Master_Buffer_Rx[0] = I2C_Master_BufferRead1Byte(I2C1, SLAVE_ADDRESS);
    printf("Master_Buffer_Rx[0]: 0x%0X\n", Master_Buffer_Rx[0]);
}

